<div class="width-limit">
    <div id="border">
        {{#Subtopic}}
        <div id="subtopic" style="font-size:.8rem;opacity:50%;margin:-0.2rem 0 .5rem;">{{Deck}}<br>{{Subtopic}}</div>
        {{/Subtopic}}
        <div id="noteTypeDiv">{{Type}}</div>
        {{Front}}
    </div>
</div>
<script>
    // [Color Theme]
    var all_colors = [
        "#F04F5D",
        "#F78766",
        "#FBB370",
        "#FFD36C",
        "#87D687",
        "#0DBCB4",
        "#1292BD",
        "#8C6DC5",
        "#B66DC5",
        "#D35E91"
    ]

    var positive = "#87D687";
    var negative = "#F04F5D";
    var mixed = "#FFD36C";
    var usable_colors = [
        "#F78766",
        "#FBB370",
        "#FFD36C",
        "#0DBCB4",
        "#1292BD",
        "#8C6DC5",
        "#B66DC5",
        "#D35E91"
    ]

    // If the colors-object contains a noteType, the card will be themed
    // according to the color that it is mapped to. -> Extensible
    var defined_colors = {
        "Advantages": positive,
        "Advantage": positive,
        "Solutions": positive,
        "Solution": positive,
        "Disadvantages": negative,
        "Disadvantage": negative,
        "Challenge": negative,
        "Challenges": negative,
        "Problem": negative,
        "Problems": negative,
        "Limitation": negative,
        "Limitations": negative,
        "Example": "#FBB370",
        "Examples": "#FBB370",
        "List": "#FFD36C",
        "Steps": "#FFD36C",
        "Definition": "#1292BD",
        "Question": "#8C6DC5",
        "Study": "#D35E91",
        "Theorem": "#D35E91",
        "Lemma": "#D35E91",
        "Default": "#0DBCB4",
        "Algorithm": "#0DBCB4",
        "Code": "#0DBCB4"
    }

    function colorHash(nt) {
        var sum = (nt.length ** 7) % 8;
        for (var i = 0; i < nt.length; i++) {
            sum = (sum + (nt.charCodeAt(i) % 52) ** 7 + (i % 3)) % 8;
        }

        return usable_colors[sum]
    }

    // Applies the given color as the color-theme
    function setColorTheme(color) {
        document.getElementById("noteTypeDiv").style.color = color;
        document.getElementById("border").style.borderColor = color;

        italic = document.querySelectorAll("i").forEach(element => { element.style.backgroundColor = color + "44"; });

    }


    var noteType = document.getElementById("noteTypeDiv").innerHTML;

    // Regular Color Setting by name
    if (Object.keys(defined_colors).includes(noteType)) {
        setColorTheme(defined_colors[noteType]);
    }

    // Studies can be very long and sometimes the "Study"-Template will
    // not suffice. (I.e. it has multiple Hypotheses etc) Therefore, if
    // a noteType starts with "Study", it will
    // be displayed as a "custom study" as well.
    else if (noteType.startsWith("Study")) {
        setColorTheme(defined_colors["Study"]);
    }
    else if (noteType != "") {
        setColorTheme(colorHash(noteType));
    }
    // include highlighting.js



</script>